# addressBookLib.py: Generate a random address book.
# Bob DuCharme no warrantee expressed or implied. 
# 
# first names: http://www.census.gov/genealogy/names/dist.male.first 
#    http://www.census.gov/genealogy/names/dist.female.first
# 
# last names http://www.census.gov/genealogy/names/dist.all.last
# 
# street names http://www.santacruzpl.org/readyref/files/q-s/stnames.shtml
# 
# cities http://www.hoobly.com/m/popular
# 
# companies http://en.wikipedia.org/wiki/List_of_Fortune_500
# 
# http://www.usps.com/ncsc/lookups/usps_abbreviations.html
# 

from random import *
from string import *
from sys import stdout

firstNames = ["James","John","Robert","Michael","William","David","Richard","Charles","Joseph","Thomas","Christopher","Daniel","Paul","Mark","Donald","George","Kenneth","Steven","Edward","Brian","Ronald","Anthony","Kevin","Jason","Matthew","Gary","Timothy","Jose","Larry","Jeffrey","Frank","Scott","Eric","Stephen","Andrew","Raymond","Gregory","Joshua","Jerry","Dennis","Walter","Patrick","Peter","Harold","Douglas","Henry","Carl","Arthur","Ryan","Roger","Joe","Juan","Jack","Albert","Jonathan","Justin","Terry","Gerald","Keith","Samuel","Willie","Ralph","Lawrence","Nicholas","Roy","Benjamin","Bruce","Brandon","Adam","Harry","Fred","Wayne","Billy","Steve","Louis","Jeremy","Aaron","Randy","Howard","Eugene","Carlos","Russell","Bobby","Victor","Martin","Ernest","Phillip","Todd","Jesse","Craig","Alan","Shawn","Clarence","Sean","Philip","Chris","Johnny","Earl","Jimmy","Antonio","Danny","Bryan","Tony","Luis","Mike","Stanley","Leonard","Nathan","Dale","Manuel","Rodney","Curtis","Norman","Allen","Marvin","Vincent","Glenn","Jeffery","Travis","Jeff","Chad","Jacob","Lee","Melvin","Alfred","Kyle","Francis","Bradley","Jesus","Herbert","Frederick","Ray","Joel","Edwin","Don","Eddie","Ricky","Troy","Randall","Barry","Alexander","Bernard","Mario","Leroy","Francisco","Marcus","Micheal","Theodore","Clifford","Miguel","Oscar","Jay","Jim","Tom","Calvin","Alex","Jon","Ronnie","Bill","Lloyd","Tommy","Leon","Derek","Warren","Darrell","Jerome","Floyd","Leo","Alvin","Tim","Wesley","Gordon","Dean","Greg","Jorge","Dustin","Pedro","Mary","Patricia","Linda","Barbara","Elizabeth","Jennifer","Maria","Susan","Margaret","Dorothy","Lisa","Nancy","Karen","Betty","Helen","Sandra","Donna","Carol","Ruth","Sharon","Michelle","Laura","Sarah","Kimberly","Deborah","Jessica","Shirley","Cynthia","Angela","Melissa","Brenda","Amy","Anna","Rebecca","Virginia","Kathleen","Pamela","Martha","Debra","Amanda","Stephanie","Carolyn","Christine","Marie","Janet","Catherine","Frances","Ann","Joyce","Diane","Alice","Julie","Heather","Teresa","Doris","Gloria","Evelyn","Jean","Cheryl","Mildred","Katherine","Joan","Ashley","Judith","Rose","Janice","Kelly","Nicole","Judy","Christina","Kathy","Theresa","Beverly","Denise","Tammy","Irene","Jane","Lori","Rachel","Marilyn","Andrea","Kathryn","Louise","Sara","Anne","Jacqueline","Wanda","Bonnie","Julia","Ruby","Lois","Tina","Phyllis","Norma","Paula","Diana","Annie","Lillian","Emily","Robin","Peggy","Crystal","Gladys","Rita","Dawn","Connie","Florence","Tracy","Edna","Tiffany","Carmen","Rosa","Cindy","Grace","Wendy","Victoria","Edith","Kim","Sherry","Sylvia","Josephine","Thelma","Shannon","Sheila","Ethel","Ellen","Elaine","Marjorie","Carrie","Charlotte","Monica","Esther","Pauline","Emma","Juanita","Anita","Rhonda","Hazel","Amber","Eva","Debbie","April","Leslie","Clara","Lucille","Jamie","Joanne","Eleanor","Valerie","Danielle","Megan","Alicia","Suzanne","Michele","Gail","Bertha","Darlene","Veronica","Jill","Erin","Geraldine","Lauren","Cathy","Joann","Lorraine","Lynn","Sally","Regina","Erica","Beatrice","Dolores","Bernice","Audrey","Yvonne","Annette","June","Samantha"]

lastNames = ["Smith","Johnson","Williams","Jones","Brown","Davis","Miller","Wilson","Moore","Taylor","Anderson","Thomas","Jackson","White","Harris","Martin","Thompson","Garcia","Martinez","Robinson","Clark","Rodriguez","Lewis","Lee","Walker","Hall","Allen","Young","Hernandez","King","Wright","Lopez","Hill","Scott","Green","Adams","Baker","Gonzalez","Nelson","Carter","Mitchell","Perez","Roberts","Turner","Phillips","Campbell","Parker","Evans","Edwards","Collins","Stewart","Sanchez","Morris","Rogers","Reed","Cook","Morgan","Bell","Murphy","Bailey","Rivera","Cooper","Richardson","Cox","Howard","Ward","Torres","Peterson","Gray","Ramirez","James","Watson","Brooks","Kelly","Sanders","Price","Bennett","Wood","Barnes","Ross","Henderson","Coleman","Jenkins","Perry","Powell","Long","Patterson","Hughes","Flores","Washington","Butler","Simmons","Foster","Gonzales","Bryant","Alexander","Russell","Griffin","Diaz","Hayes","Myers","Ford","Hamilton","Graham","Sullivan","Wallace","Woods","Cole","West","Jordan","Owens","Reynolds","Fisher","Ellis","Harrison","Gibson","Mcdonald","Cruz","Marshall","Ortiz","Gomez","Murray","Freeman","Wells","Webb","Simpson","Stevens","Tucker","Porter","Hunter","Hicks","Crawford","Henry","Boyd","Mason","Morales","Kennedy","Warren","Dixon","Ramos","Reyes","Burns","Gordon","Shaw","Holmes","Rice","Robertson","Hunt","Black","Daniels","Palmer","Mills","Nichols","Grant","Knight","Ferguson","Rose","Stone","Hawkins","Dunn","Perkins","Hudson","Spencer","Gardner","Stephens","Payne","Pierce","Berry","Matthews","Arnold","Wagner","Willis","Ray","Watkins","Olson","Carroll","Duncan","Snyder","Hart","Cunningham","Bradley","Lane","Andrews","Ruiz","Harper","Fox","Riley","Armstrong","Carpenter","Weaver","Greene","Lawrence","Elliott","Chavez","Sims","Austin","Peters","Kelley","Franklin","Lawson","Fields","Gutierrez","Ryan","Schmidt"]

streetNamePart1 = ["2nd","Second","Highland","3rd","Third","Johnson","1st","First","Forest","4th","Fourth","Jefferson","Park","Hickory","5th","Fifth","Wilson","Main","River","6th","Sixth","Meadow","Oak","Valley","7th","Seventh","Smith","Pine","East","Maple","Chestnut","Cedar","13th","Thirteenth","8th","Eighth","Franklin","Elm","Adams","View","14th","Fourteenth","Washington","Spruce","9th","Ninth","Laurel","Lake","Davis","Hill","Birch","Walnut","Williams","10th","Tenth","Lee","Spring","Dogwood","North","Green","Ridge","Poplar","Lincoln","Locust","Church","Woodland","Willow","Taylor","Mill","Ash","Sunset","Madison","Railroad","15th","Fifteenth","11th","Eleventh","Hillcrest","Jackson","Sycamore","Cherry","Broadway","West","Miller","South","Lakeview","12th","Twelfth","College","Center","Central"]

streetNamePart2 = ["St.","Ave.","Road","Lane"]

cities = ["Austin","Baltimore","Boston","Calgary","Charlotte","Chicago","Columbus","Dallas","Denver","Detroit","Edmonton","El Paso","Fort Worth","Halifax","Hamilton","Houston","Indianapolis","Jacksonville","Kitchener","Las Vegas","London","Los Angeles","Memphis","Milwaukee","Montreal","Nashville","New York","Oklahoma City","Oshawa","Ottawa","Philadelphia","Phoenix","Pittsburgh","Portland","Quebec","Regina","San Antonio","San Diego","San Francisco","San Jose","Saskatoon","Seattle","St Catharines","St Johns","Sudbury","Toronto","Tucson","Vancouver","Victoria","Washington","Windsor","Winnipeg"]

states = ["AL","AK","AS","AZ","AR","CA","CO","CT","DE","DC","FM","FL","GA","GU","HI","ID","IL","IN","IA","KS","KY","LA","ME","MH","MD","MA","MI","MN","MS","MO","MT","NE","NV","NH","NJ","NM","NY","NC","ND","MP","OH","OK","OR","PW","PA","PR","RI","SC","SD","TN","TX","UT","VT","VI","VA","WA","WV","WI","WY"]

companies = ["Hormel Foods","Goodrich","Hovnanian Enterprises","Leggett and Platt","Energy East","Omnicare","Kelly Services","Liberty Global","Darden Restaurants","NVR","CarMax","Yahoo","Charter Communications","Cablevision Systems","Lexmark International","Mattel","Timken","Charles Schwab","Bed Bath and Beyond","USG","Erie Insurance Group","Barnes and Noble","RadioShack","US Airways Group","Jones Apparel Group","Auto-Owners Insurance","Rockwell Automation","W.R. Berkley","Beazer Homes USA","Atmos Energy","Ross Stores","Triad Hospitals","Temple-Inland","Avaya","Maytag","UGI","MDC Holdings","Micron Technology","Stryker","Liz Claiborne","Pacific Life","Hershey","Owens and Minor","Ryland Group","Henry Schein","SPX","SCANA","Emcor Group","Whole Foods Market","Longs Drug Stores","Chesapeake Energy","National Oilwell Varco","Peabody Energy","Engelhard","El Paso","Corning","Nash Finch","EBay","Ecolab","Clorox","Newmont Mining","Hexion Specialty Chemicals","Tenneco","Hilton Hotels","Big Lots","Wesco International","H and R Block","United Stationers","Ikon Office Solutions","The Mosaic Company","Affiliated Computer Svcs.","Conseco","Western and Southern Financial","Franklin Resources","BorgWarner","Graybar Electric","Advance Auto Parts","Jefferson-Pilot","Mirant","Freeport-McMoRan Cpr. and Gld","CNF","Wm. Wrigley Jr.","Peter Kiewit Sons'","Levi Strauss","Universal Health Svcs.","Lubrizol","Constellation Brands","Fiserv","Sealed Air","Borders Group","Mutual of Omaha Ins.","American Financial Grp.","Standard Pacific","ServiceMaster","SunGard Data Systems","Frontier Oil","Pathmark Stores","Kindred Healthcare","Marshall and Ilsley Corp.","LandAmerica Financial"]


def q(string):
  # return string in quotes followed by a comma
  return '"' + string + '",'

def firstName():
  return choice(firstNames)

def lastName():
  return choice(lastNames)

def middleName():
  i = randint(1,3)
  if (i == 1):
    return firstName()
  elif (i == 2):   # middle initial + period
    return firstName()[0:1] + "."
  else:
    return ""
    
def streetName():
  return choice(streetNamePart1) + " " + choice(streetNamePart2)

def city():
  return choice(cities)

def stateCode():
    return choice(states)

def company():
  return choice(companies)

def someInt():   # used for house number, apt. number, etc. 
    return str(randint(0,4999))

def zipCode():
    part2 = ""
    if randint(0,2) > 1:
        part2 = "-" + str(randint(1000,9999))
    part1 = str(randint(10000,99999))
    return part1 + part2

def phoneNumber():
    return "(" + str(randint(100,999)) + ") " + str(randint(100,999)) + "-" + str(randint(1000,9999)) 

def birthday():
    return str(randint(1,12)) + "/" + str(randint(1,28)) + "/" + str(1950 + randint(1,65))


def categories():
  # See children() for ideas about creating multiple values here in a comma-
  # delimited list.
  i = randint(0,7)
  if i == 1:
    cats = "personal"
  elif i == 2:
    cats = "business"
  elif i == 3:
    cats = "musician"
  elif i == 4:
    cats = "soccer"
  else:
    cats = ""
  return cats

def children():
  children = ""
  if randint(0,1) < 1:
    for i in range(1,randint(1,4)):
      children = children + firstName() + "\\,"
  return children[0:len(children) - 2] # lose final \,

def jobTitle():
  title = ''
  if randint(1,5) == 1:
     title = 'Dr.'
  return title;

def nameSuffix():
  suffix = ''
  if randint(1,5) == 1:
     suffix = 'Jr.'
  return suffix;

def optionalAddrLine():
  i = randint(1,8)
  if (i == 1):
    aLine = "Suite " + someInt();
  elif (i == 2): 
    aLine = "Apt. " + someInt();
  else:
    return ""

  return aLine;


def companyDomainName(companyName):
  # Won't necessarily be the real domain name.
  domainName = replace(companyName,'.','') + ".com"
  return lower(replace(domainName,' ',''))

def companyEmailAddr(firstName,lastName,compDomainName):
  return lower(firstName + "." + lastName + "@") + compDomainName

def homeEmailAddr(firstName):
  i = randint(0,4)
  if i == 1:
    domainName = "earthlink.net"
  elif i == 2:
    domainName = "gmail.com"
  elif i == 3:
    domainName = "yahoo.com"
  elif i == 4:
    domainName = "msn.com"
  else:
    domainName = "hotmail.com"
  return lower(firstName + lower(str(randint(10,1000)) + "@" + domainName))


