# generateEudoraAbook.py: generate a CSV file of the form exported by
# Eudora.
# Bob DuCharme no warrantee expressed or implied. 

import sys
from addressBookLib import *


def generateRecord():
  # Save the following because they're used to create some of the other values.
  fn = firstName()
  ln = lastName()
  comp = company()
  compDomainName = companyDomainName(comp)

  note = ""
  if randint(0,2) < 1:
    note = "Here is a sample note.\\n\\nThat was two carriage returns."

  rec = ''
  
  # nickname,email1,fullName,firstName,
  rec = rec + q(fn) + q(homeEmailAddr(fn)) + q(fn + " " + ln) + q(fn)
  # lastName,address,city,state,
  rec = rec + q(ln) + q(someInt() + " " + streetName()) + q(city()) + q(stateCode())
  # country,zip,phone,fax,
  rec = rec + '"US",' + q(zipCode()) + q(phoneNumber()) + q(phoneNumber())
  # mobile,web,workOrganization,
  rec = rec + q(phoneNumber()) + q("http://www." +  compDomainName + "/" + fn) + q(comp)
  # workTitle,workAddress,workCity,workState,
  rec = rec + q(jobTitle()) + q(someInt() + " " + streetName()) + q(city()) + q(stateCode())
  # workCountry,workZip,
  rec = rec + '"US",' + q(zipCode())
  # workPhone,workFax,workMobile,
  rec = rec + q(phoneNumber()) + q(phoneNumber()) + q(phoneNumber())
  # workWebAddress,otherEmail,otherPhone,
  rec = rec + q("http://www." + compDomainName) + q(companyEmailAddr(fn,ln,compDomainName)) + q(phoneNumber())
  # otherWebPages, notes
  rec = rec + '"","' + note + '"'

  return rec


# --- Main program


if __name__ == "__main__":

    if len(sys.argv) != 2:
        print "Enter\n\n  python generateEudoraAbook.py  N\n"
        print "where N is the number of CSV records to output."
        sys.exit()

    recs2Create = int(sys.argv[1]) + 1;
    for r in range(1,recs2Create):
      print generateRecord(),
      #MySQL doesn't like a carriage return at the end of the last line. 
      if r < recs2Create - 1:
        print;

